#ifndef __CURSES_OUTPUT_H__
#define __CURSES_OUTPUT_H__

#include <utility>
#include <memory>
#include "cursor.h"
#include "display.h"

class curses_output final : public display {
private:
        std::unique_ptr<cursor> &curse;
public:
        curses_output(std::unique_ptr<cursor> &new_curse);

        void render() override;
        void clear() override;
        void print_char(const position &pos,
                        const char ch, const int attr) override;
        void print_str(const position &pos,
                       const std::string &str, const int attr) override;
};

#endif
